[![Maintenance](https://img.shields.io/badge/Maintained%3F-yes-green.svg)](https://GitHub.com/teniryte/xyaml/graphs/commit-activity) [![Maintaner](https://img.shields.io/badge/Maintainer-teniryte-blue)](https://img.shields.io/badge/maintainer-teniryte-blue) [![Website shields.io](https://img.shields.io/website-up-down-green-red/http/shields.io.svg)](https://xyaml.sencort.com/) [![made-with-Markdown](https://img.shields.io/badge/Made%20with-Markdown-1f425f.svg)](http://commonmark.org) [![made-for-VSCode](https://img.shields.io/badge/Made%20for-VSCode-1f425f.svg)](https://code.visualstudio.com/) [![GitHub license](https://img.shields.io/github/license/teniryte/xyaml.svg)](https://github.com/teniryte/xyaml/blob/master/LICENSE) [![Profile views](https://gpvc.arturio.dev/teniryte)](https://gpvc.arturio.dev/teniryte) [![GitHub contributors](https://img.shields.io/github/contributors/teniryte/xyaml.svg)](https://GitHub.com/teniryte/xyaml/graphs/contributors/) [![GitHub issues](https://img.shields.io/github/issues/teniryte/xyaml.svg)](https://GitHub.com/teniryte/xyaml/issues/)

[![GitHub forks](https://img.shields.io/github/forks/teniryte/xyaml.svg?style=social&label=Fork&maxAge=2592000)](https://GitHub.com/teniryte/xyaml/network/) [![GitHub stars](https://img.shields.io/github/stars/teniryte/xyaml.svg?style=social&label=Star&maxAge=2592000)](https://GitHub.com/teniryte/xyaml/stargazers/) [![GitHub watchers](https://img.shields.io/github/watchers/teniryte/xyaml.svg?style=social&label=Watch&maxAge=2592000)](https://GitHub.com/teniryte/xyaml/watchers/) [![GitHub followers](https://img.shields.io/github/followers/teniryte.svg?style=social&label=Follow&maxAge=2592000)](https://github.com/teniryte?tab=followers)

# xyaml

>
>
>
  YAML extensions


- **Including & importing yaml, json, js files**
- **Expressions interpolation**
- **JavaScript-functions in YAML-code**
- **Evaluating instructions**

## Loading YAML-file

```js
const xyaml = require('xyaml');

let data  = xyaml.loadFile('./data.yaml');
```

## Extended YAML syntax

### Example

```yaml
# Plain properties
username: teniryte
email: teniryte@gmail.com
age: 25

# Interpolation
paths:
  users: /home
  home: ${users}/teniryte
  work: ${home}/work
  config: ${work}/config
  # Current scope link
  packages: ${self.work}/packages
  # Root scope link
  tools: ${root.paths.work}/tools
  current:
    # Parent scope link
    package: ${parent.packages}/1


# Embedded functions
math:
  base: 2
  methods:
    add: (a, b) => {
      return a + b + parent.base;
    };
    sub: (a, b) => {
      return a - b + parent.base;
    };

  results:
    # 5
    - ${methods.add(1, 2)}
    # 3
    - ${methods.sub(2, 1)}

# Include module (includes all module properties into current object)
included:
  ~include: logger.js
  ~include: https://cdn.cort.one/xyaml/test/fruits.yaml
  ~include: colors.yaml
  ~include: package.json
  # Include files fruits.yaml, languages.yaml
  ~include:
    - fruits
    - languages

# Import module (incapsulates module into it's own scope)
imported:
  logger: ~import logger.js
  fruits: ~import https://cdn.cort.one/xyaml/test/fruits.yaml
  package: ~import package.json

eval:
  - self.delete('math.add');
```

### Import JavaScript module

> `readfiles.js`

```js
'use strict';

const fs = require('fs');
const path = require('path');

let [dirname] = process.argv;

module.exports = fs.readdirSync(path.resolve(__dirname, dirname));
```

> `data.yaml`

```yaml
files: ~import files.js ../../lib
```
